unit FormMain;

interface

uses
   Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ComCtrls, StdCtrls, Spin, Gauges;

const

   // input and out buffer size constants...
   BufferInSize  = 64;
   BufferOutSize = 64;
type

   // input and output buffers...
   TBufferIn = array[0..BufferInSize] of byte;
   TBufferOut = array[0..BufferOutSize] of byte;

   // main form
   TForm1 = class(TForm)
    Mesurer: TButton;
    Button1: TButton;
    SpinEdit1: TSpinEdit;
    SpinEdit2: TSpinEdit;
    Label1: TLabel;
    Label2: TLabel;
    Gauge1: TGauge;
    Label3: TLabel;
    Memo1: TMemo;
    Button2: TButton;
    procedure Button1Click(Sender: TObject);
    procedure MesurerClick(Sender: TObject);
      procedure FormCreate(Sender: TObject);
      procedure FormDestroy(Sender: TObject);
    procedure Button2Click(Sender: TObject);
   private
      FBufferIn:TBufferIn;
      FBufferOut:TBufferOut;
      function USBEvent(var Msg: TMessage): Boolean;
      function Refresh (): integer;
   public
   end;

var
  Form1: TForm1;

implementation

uses
   cUSBInterface,
   cUSBInterfaceTypes;

const

   // vendor and product ID constants...
   VENDOR_ID           = 1240;
   PRODUCT_ID          = 0005;

{$R *.DFM}

{
****************************************************************************
* Name    : Create                                                         *
* Purpose : Create the main form                                           *
****************************************************************************
}
procedure TForm1.FormCreate(Sender: TObject);
begin
   Application.HookMainWindow(USBEvent);
   Connect(Application.Handle);
end;
{
****************************************************************************
* Name    : Destroy                                                        *
* Purpose : Free the main form                                             *
****************************************************************************
}
procedure TForm1.FormDestroy(Sender: TObject);
begin
   Application.UnHookMainWindow(USBEvent);
end;
{
****************************************************************************
* Name    : USBEvent                                                       *
* Purpose : DLL message handler hook                                       *
****************************************************************************
}
function TForm1.Refresh(): integer;
  var i : integer;
  var valeur : integer;
begin

     if (FBufferIn[1]=255) then begin

       valeur := FBufferIn[2]*4 + round(FBufferIn[3]/64);

       gauge1.Progress :=round(100*valeur/1024);

       label3.caption  :='La valeur est : '+floattostrf(5 * valeur/1024,ffFixed,3,2)+' Volt';
     end;
     result := 0;
end;


function TForm1.USBEvent(var Msg: TMessage): Boolean;
var
   DevHandle:cardinal;
//   TextBuffer:array[0..255] of char;
begin
  result := False;
  if Msg.Msg = WM_HID_EVENT then
  begin
     case Msg.WParam of

        // a HID device has been plugged in...
        NOTIFY_PLUGGED :
        begin

           // is it our HID device...
           DevHandle := Msg.LParam; // handle of HID device in this message
           if (GetVendorID(DevHandle) = VENDOR_ID) and (GetProductID(DevHandle) = PRODUCT_ID) then
           begin
              // add your code here, for example...
              // GetProductName(DevHandle, TextBuffer, 256);
              // ALabel.Caption := string(TextBuffer);
           end;
           result := true;
        end;

        // a HID device has been device removed...
        NOTIFY_UNPLUGGED :
        begin

           // is it our HID device...
           DevHandle := Msg.LParam; // handle of HID device in this message
           if (GetVendorID(DevHandle) = VENDOR_ID) and (GetProductID(DevHandle) = PRODUCT_ID) then
           begin
              // add you code here
           end;
           result := true;
        end;

        // a HID device has been attached or removed. This event is fired after
        // either NotifyPlugged or NotifyUnplugged.
        NOTIFY_CHANGED :
        begin
           // get the handle of the device we are interested in
           // and set it's read notification flag to true...
           DevHandle := GetHandle(VENDOR_ID,PRODUCT_ID);
           SetReadNotify(DevHandle,true);
           result := true;
        end;

        // a HID device has sent some data..
        NOTIFY_READ :
        begin
           DevHandle := Msg.LParam; // handle of HID device in this message
           if (GetVendorID(DevHandle) = VENDOR_ID) and (GetProductID(DevHandle) = PRODUCT_ID) then
           begin
               // read the data - remember that first byte is report ID...
               Read(DevHandle,@FBufferIn);

               Button2Click(nil);
               //Refresh


               // process data here...
           end;
           result := true;
        end;
     end;
  end;
end;

(*
   if you want to write some data to the USB device, then
   try using something like this...

   // first element is report ID, set to 0...
   FBufferOut[0] := $0;

   // fill the buffer with some data...
   for index := 1 to BufferOutSize do
      FBufferOut[index] := index;

   DevHandle := GetHandle(VendorID, ProductID);
   Write(DevHandle,@FBufferOut);
*)

procedure TForm1.MesurerClick(Sender: TObject);
  var index : integer;
  var DevHandle:cardinal;
begin
// mise  0 du buffer
   FBufferOut[1] := $0;    // on met le buffer[0] a 0

// Attribution de la carte usb
   DevHandle := GetHandle(VENDOR_ID , PRODUCT_ID);
   Write(DevHandle,@FBufferOut);

end;

procedure TForm1.Button1Click(Sender: TObject);
  var index : integer;
  var DevHandle:cardinal;
  var i : integer;
begin
// mise  0 du buffer
   FBufferOut [1]:= 1 ;
   FBufferOut [2]:= 20 ;
   FBufferOut [3]:= 3 ;
   FBufferOut [4]:= 4 ;



// Attribution de la carte usb
   DevHandle := GetHandle(VENDOR_ID , PRODUCT_ID);
  Write(DevHandle,@FBufferOut);
end;

procedure TForm1.Button2Click(Sender: TObject);
  var index : integer;
  var DevHandle:cardinal;
  var i : integer;
begin
// mise  0 du buffer
        i:=5;
   FBufferOut [1]:= 1 ;
   FBufferOut [2]:= 7 ;
   FBufferOut [3]:= i ;
   FBufferOut [4]:= 10;
   FBufferOut [5]:= 7 ;
   FBufferOut [6]:= (50-i) ;
   FBufferOut [7]:= 1 ;
   FBufferOut [8]:= 7;
   FBufferOut [9]:= i ;
   FBufferOut [10]:= 10 ;
   FBufferOut [11]:= 7 ;
   FBufferOut [12]:= (50-i);
   FBufferOut [13]:= 1 ;
   FBufferOut [14]:= 7 ;
   FBufferOut [15]:= i ;
   FBufferOut [16]:= 10;
   FBufferOut [17]:= 7 ;
   FBufferOut [18]:= (50-i) ;
   FBufferOut [19]:= 1 ;
   FBufferOut [20]:= 7;
   FBufferOut [21]:= i ;
   FBufferOut [22]:= 10 ;
   FBufferOut [23]:= 7;
   FBufferOut [24]:= (50-i);
   FBufferOut [25]:= 1 ;
   FBufferOut [26]:= 7 ;
   FBufferOut [27]:= i ;
   FBufferOut [28]:= 10;
   FBufferOut [29]:= 7 ;
   FBufferOut [30]:= (50-i) ;
   FBufferOut [31]:= 1 ;
   FBufferOut [32]:= 7;
   FBufferOut [33]:= i ;
   FBufferOut [34]:= 10 ;
   FBufferOut [35]:= 7;
   FBufferOut [36]:= (50-i) ;
   FBufferOut [37]:= 1 ;
   FBufferOut [38]:= 7;
   FBufferOut [39]:= i;
   FBufferOut [40]:= 10;
   FBufferOut [41]:= 7 ;
   FBufferOut [42]:= (50-i) ;
   FBufferOut [43]:= 1 ;
   FBufferOut [44]:= 7;
   FBufferOut [45]:= i;
   FBufferOut [46]:= 10;
   FBufferOut [47]:= 7;
   FBufferOut [48]:= (50-i);
   FBufferOut [49]:= 1 ;
   FBufferOut [50]:= 7 ;
   FBufferOut [51]:= i ;
   FBufferOut [52]:= 10;
   FBufferOut [53]:= 7;
   FBufferOut [54]:= (50-i) ;
   FBufferOut [55]:= 1 ;
   FBufferOut [56]:= 7 ;
   FBufferOut [57]:= i;
   FBufferOut [58]:= 10 ;
   FBufferOut [59]:= 7 ;
   FBufferOut [60]:= (50-i) ;
   FBufferOut [61]:= 0;
   FBufferOut [62]:= 0;
   FBufferOut [63]:= 0 ;
   FBufferOut [64]:= 0 ;
// Attribution de la carte usb
   DevHandle := GetHandle(VENDOR_ID , PRODUCT_ID);
  Write(DevHandle,@FBufferOut);
end;

end.


